Index: branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs	(revision 14693)
+++ branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs	(revision 14701)
@@ -78,5 +78,5 @@
       double[,] factorMatrix = AlglibUtil.PrepareInputMatrix(dataset, factorVariables, rows);
 
-      inputMatrix = factorMatrix.VertCat(inputMatrix);
+      inputMatrix = factorMatrix.HorzCat(inputMatrix);
 
       if (inputMatrix.Cast<double>().Any(x => double.IsNaN(x) || double.IsInfinity(x)))
Index: branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 14693)
+++ branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 14701)
@@ -79,5 +79,5 @@
       double[,] binaryMatrix = AlglibUtil.PrepareInputMatrix(dataset, factorVariables, rows);
       double[,] doubleVarMatrix = AlglibUtil.PrepareInputMatrix(dataset, doubleVariables.Concat(new string[] { targetVariable }), rows);
-      var inputMatrix = binaryMatrix.VertCat(doubleVarMatrix);
+      var inputMatrix = binaryMatrix.HorzCat(doubleVarMatrix);
 
       if (inputMatrix.Cast<double>().Any(x => double.IsNaN(x) || double.IsInfinity(x)))
Index: branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitClassification.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitClassification.cs	(revision 14693)
+++ branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitClassification.cs	(revision 14701)
@@ -76,5 +76,5 @@
       var factorVariableValues = AlglibUtil.GetFactorVariableValues(dataset, factorVariableNames, rows);
       var factorMatrix = AlglibUtil.PrepareInputMatrix(dataset, factorVariableValues, rows);
-      inputMatrix = factorMatrix.VertCat(inputMatrix);
+      inputMatrix = factorMatrix.HorzCat(inputMatrix);
 
       if (inputMatrix.Cast<double>().Any(x => double.IsNaN(x) || double.IsInfinity(x)))
Index: branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitModel.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitModel.cs	(revision 14693)
+++ branches/symbreg-factors-2650/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitModel.cs	(revision 14701)
@@ -100,5 +100,5 @@
       double[,] factorData = AlglibUtil.PrepareInputMatrix(dataset, factorVariables, rows);
 
-      inputData = factorData.VertCat(inputData);
+      inputData = factorData.HorzCat(inputData);
 
       int n = inputData.GetLength(0);
Index: branches/symbreg-factors-2650/HeuristicLab.Common/3.3/MatrixExtensions.cs
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Common/3.3/MatrixExtensions.cs	(revision 14693)
+++ branches/symbreg-factors-2650/HeuristicLab.Common/3.3/MatrixExtensions.cs	(revision 14701)
@@ -39,10 +39,10 @@
 
     /// <summary>
-    /// Concatenates matrices horizontally.
+    /// Concatenates matrices vertically.
     /// A      B
     /// 1 2    9 8
     /// 3 4    7 6
     /// 
-    /// HorzCat(A, B)
+    /// VertCat(A, B)
     /// 1 2 
     /// 3 4
@@ -54,5 +54,5 @@
     /// <param name="b"></param>
     /// <returns>A new matrix with the number of rows = a.GetLength(0) + b.GetLength(0)</returns>
-    public static T[,] HorzCat<T>(this T[,] a, T[,] b) {
+    public static T[,] VertCat<T>(this T[,] a, T[,] b) {
       Contract.Assert(a.GetLength(1) == b.GetLength(1));
       var aLen = a.GetLength(0);
@@ -68,11 +68,12 @@
       return result;
     }
+
     /// <summary>
-    /// Concatenates matrices vertically.
+    /// Concatenates matrices horizontally.
     /// A      B
     /// 1 2    9 8
     /// 3 4    7 6
     /// 
-    /// VertCat(A, B)
+    /// HorzCat(A, B)
     /// 1 2 9 8
     /// 3 4 7 6
@@ -82,5 +83,5 @@
     /// <param name="b"></param>
     /// <returns>A new matrix with the number of columns = a.GetLength(1) + b.GetLength(1)</returns>
-    public static T[,] VertCat<T>(this T[,] a, T[,] b) {
+    public static T[,] HorzCat<T>(this T[,] a, T[,] b) {
       Contract.Assert(a.GetLength(0) == b.GetLength(0));
       var aLen = a.GetLength(1);