Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IArc.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IArc.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IArc.cs	(revision 14712)
@@ -24,4 +24,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("04788331-AEC8-4D8B-801E-1600F164CEC6")]
   public interface IArc : IItem {
     IVertex Source { get; }
@@ -33,4 +34,5 @@
   }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("AF7C35B1-3040-481A-AE19-FFDE4C517AF5")]
   public interface IArc<T> : IArc where T : class,IDeepCloneable {
     T Data { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IDirectedGraph.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IDirectedGraph.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IDirectedGraph.cs	(revision 14712)
@@ -25,4 +25,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("BE794FC7-7DAF-4828-8014-2714A8BA2140")]
   public interface IDirectedGraph : IItem {
     IEnumerable<IVertex> Vertices { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IVertex.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IVertex.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/DirectedGraph/IVertex.cs	(revision 14712)
@@ -25,4 +25,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("3677EA7A-B956-47D1-BEDA-5041CA5A7903")]
   public interface IVertex : IItem {
     IEnumerable<IArc> InArcs { get; }
@@ -44,4 +45,5 @@
   }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("5184E468-DA53-4D59-B86D-5DC000E17B57")]
   public interface IVertex<T> : IVertex where T : class, IDeepCloneable {
     T Data { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IAtomicOperation.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IAtomicOperation.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IAtomicOperation.cs	(revision 14712)
@@ -24,4 +24,5 @@
   /// Interface which represents an atomic operation.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("86835DA1-C81F-4B64-A4B5-18CAE447946A")]
   public interface IAtomicOperation : IOperation {
     IOperator Operator { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedItemCollection.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedItemCollection.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedItemCollection.cs	(revision 14712)
@@ -24,4 +24,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("5AD53CE8-EBEA-4A04-9CAB-8C2BC76D4F68")]
   public interface ICheckedItemCollection<T> : IItemCollection<T> where T : class, IItem {
     event CollectionItemsChangedEventHandler<T> CheckedItemsChanged;
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedItemList.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedItemList.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedItemList.cs	(revision 14712)
@@ -24,4 +24,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("F6D65667-A61A-44FB-B8FD-48F69EC9634B")]
   public interface ICheckedItemList<T> : IItemList<T> where T : class, IItem {
     event CollectionItemsChangedEventHandler<IndexedItem<T>> CheckedItemsChanged;
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedMultiOperator.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedMultiOperator.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ICheckedMultiOperator.cs	(revision 14712)
@@ -22,4 +22,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("BB0FEE39-D47C-40C9-BDC8-A76031F128B7")]
   public interface ICheckedMultiOperator<T> : IMultiOperator<T> where T : class,IOperator {
     new ICheckedItemList<T> Operators { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IConstrainedValueParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IConstrainedValueParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IConstrainedValueParameter.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("885DBB6F-B7D8-4DDA-AC3C-93A0AAC1D6E6")]
   public interface IConstrainedValueParameter<T> : IValueParameter<T> where T : class, IItem {
     IItemSet<T> ValidValues { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IEngine.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IEngine.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IEngine.cs	(revision 14712)
@@ -21,4 +21,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("1113B353-2DC7-45DA-89BA-52E90B68BC0A")]
   public interface IEngine : IExecutable {
     ILog Log { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IExecutable.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IExecutable.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IExecutable.cs	(revision 14712)
@@ -24,4 +24,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("3EB0D896-474B-4CFA-97E3-2AEE53B8F800")]
   public interface IExecutable : IItem {
     ExecutionState ExecutionState { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IExecutionContext.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IExecutionContext.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IExecutionContext.cs	(revision 14712)
@@ -26,4 +26,5 @@
   /// Interface which represents an execution context.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("E496C4CF-C054-4A6A-9F50-59D8AD8C15DD")]
   public interface IExecutionContext : IDeepCloneable {
     IExecutionContext Parent { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IFixedValueParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IFixedValueParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IFixedValueParameter.cs	(revision 14712)
@@ -21,4 +21,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("E5341A71-6CF2-4C76-8EBE-DD38021B8821")]
   public interface IFixedValueParameter : IValueParameter {
     new IItem Value { get; }
@@ -26,4 +27,5 @@
   }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("8148DCB7-C903-44B0-991B-84F2D0F45B89")]
   public interface IFixedValueParameter<T> : IFixedValueParameter, IValueParameter<T> where T : class, IItem {
     new T Value { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IInstrumentedOperator.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IInstrumentedOperator.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IInstrumentedOperator.cs	(revision 14712)
@@ -26,4 +26,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("E4587D35-7FAA-49ED-A25C-D5A1AF65A660")]
   public interface IInstrumentedOperator : IOperator {
     IEnumerable<IOperator> BeforeExecutionOperators { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItem.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 14712)
@@ -28,4 +28,5 @@
   /// Interface to represent (almost) every HeuristicLab object (an object, an operator,...).
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("64DC125A-E8E3-45D1-B72E-3176545F5E59")]
   public interface IItem : IContent, IDeepCloneable {
     string ItemName { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemArray.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemArray.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemArray.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("1B34F671-D16A-4DD0-9FA3-88001820E81F")]
   public interface IItemArray<T> : IObservableArray<T>, IItem where T : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemCollection.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemCollection.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemCollection.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("96F0AD3E-51CF-40F5-8B03-115C9499B931")]
   public interface IItemCollection<T> : IObservableCollection<T>, IItem where T : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemDictionary.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemDictionary.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemDictionary.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("A3D0F51B-48AC-4514-B786-440EA53563D4")]
   public interface IItemDictionary<TKey, TValue> : IObservableDictionary<TKey, TValue>, IItem
     where TKey : class, IItem
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemList.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemList.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemList.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("F59E035C-BD9F-49F1-A001-0FA0B0E841C8")]
   public interface IItemList<T> : IObservableList<T>, IItemCollection<T>, IItem where T : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemSet.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemSet.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IItemSet.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("46D33E44-C213-4FAA-99B0-1F1F27303AD5")]
   public interface IItemSet<T> : IObservableSet<T>, IItemCollection<T>, IItem where T : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IKeyedItemCollection.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IKeyedItemCollection.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IKeyedItemCollection.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("F562CF39-A889-442B-857F-5304A6CC30E0")]
   public interface IKeyedItemCollection<TKey, TItem> : IObservableKeyedCollection<TKey, TItem>, IItemCollection<TItem>, IItem where TItem : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ILog.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ILog.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ILog.cs	(revision 14712)
@@ -25,4 +25,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("228C3D45-8073-4573-BD94-665753F4C5B2")]
   public interface ILog : IItem {
     IEnumerable<string> Messages { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ILookupParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ILookupParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/ILookupParameter.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("4787DE26-3E2E-46B0-97B8-E3F2378DF639")]
   public interface ILookupParameter : IParameter {
     string ActualName { get; set; }
@@ -30,4 +31,5 @@
   }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("0FCD4510-FFF5-428C-96D2-C4BD579209D2")]
   public interface ILookupParameter<T> : ILookupParameter where T : class, IItem {
     new T ActualValue { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IMultiOperator.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IMultiOperator.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IMultiOperator.cs	(revision 14712)
@@ -22,4 +22,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("3D0C9FBD-C62D-4D40-BAE1-2861AAC9DDC2")]
   public interface IMultiOperator<T> : IOperator where T : class,IOperator {
     IItemList<T> Operators { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/INamedItem.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/INamedItem.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/INamedItem.cs	(revision 14712)
@@ -24,4 +24,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("94076B82-0D5A-4947-B215-081960703C0B")]
   public interface INamedItem : IItem {
     string Name { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperation.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperation.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperation.cs	(revision 14712)
@@ -26,4 +26,5 @@
   /// Interface which represents an operation.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("AEEAE263-9A01-4E41-97B4-1304837C5715")]
   public interface IOperation : IDeepCloneable { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperator.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 14712)
@@ -27,4 +27,5 @@
   /// Interface to represent an operator.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("B33272FA-A1E8-44F0-B5A2-4C5282ED9F8C")]
   public interface IOperator : IParameterizedNamedItem {
     bool Breakpoint { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperatorGraphOperator.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperatorGraphOperator.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IOperatorGraphOperator.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("7C147CB7-EFCB-46CC-8473-61318E607020")]
   public interface IOperatorGraphOperator : IOperator {
     OperatorGraph OperatorGraph { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameter.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("1B4C936E-0E63-47B4-BB15-D555F2171736")]
   public interface IParameter : INamedItem {
     Type DataType { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameterizedItem.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameterizedItem.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameterizedItem.cs	(revision 14712)
@@ -26,4 +26,5 @@
   /// An interface which represents an item which contains parameters.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("247BB170-EF3B-4818-A78D-2F3B71ED07E8")]
   public interface IParameterizedItem : IItem {
     IKeyedItemCollection<string, IParameter> Parameters { get; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameterizedNamedItem.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameterizedNamedItem.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IParameterizedNamedItem.cs	(revision 14712)
@@ -24,4 +24,5 @@
   /// An interface which represents an item which has a name and contains parameters.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("B08F2C6E-0B95-463F-9453-883C6F34FFC1")]
   public interface IParameterizedNamedItem : INamedItem, IParameterizedItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IProgrammableItem.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IProgrammableItem.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IProgrammableItem.cs	(revision 14712)
@@ -21,4 +21,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("B4C8615C-87B4-4A7B-B69F-3A5442A52AFC")]
   public interface IProgrammableItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IRandom.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IRandom.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IRandom.cs	(revision 14712)
@@ -24,4 +24,5 @@
   /// Represents an interface for random number generators.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("F3A14B84-FE84-42B7-9A2C-8526CED04FE0")]
   public interface IRandom : IItem {
     /// <summary>
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IScope.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IScope.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IScope.cs	(revision 14712)
@@ -24,4 +24,5 @@
   /// Hierarchical container of variables (and of subscopes).
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("B8A8626B-6CE7-4713-8B79-CDC8A159FC2E")]
   public interface IScope : INamedItem {
     IScope Parent { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IScopeTreeLookupParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IScopeTreeLookupParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IScopeTreeLookupParameter.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("11B21F00-55B3-44E5-9789-2BB0254ECEF1")]
   public interface IScopeTreeLookupParameter : ILookupParameter {
     int Depth { get; set; }
@@ -28,4 +29,5 @@
   }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("D3566CC9-4A6A-48C7-9AE5-138036EFB86C")]
   public interface IScopeTreeLookupParameter<T> : IScopeTreeLookupParameter, ILookupParameter<ItemArray<T>> where T : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IStatefulItem.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IStatefulItem.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IStatefulItem.cs	(revision 14712)
@@ -21,4 +21,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("AD9498C3-1566-45AF-AC7C-B108D01526CF")]
   public interface IStatefulItem : IItem {
     void InitializeState();
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IValueLookupParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IValueLookupParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IValueLookupParameter.cs	(revision 14712)
@@ -21,6 +21,8 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("A18F8E60-F10C-46EA-8EF2-150274C12BED")]
   public interface IValueLookupParameter : IValueParameter, ILookupParameter { }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("8107AE79-9DEC-4B24-AE40-72DF7BACB9DC")]
   public interface IValueLookupParameter<T> : IValueLookupParameter, IValueParameter<T>, ILookupParameter<T> where T : class, IItem { }
 }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IValueParameter.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IValueParameter.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IValueParameter.cs	(revision 14712)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Core {
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("152855B8-765A-47DC-A3EB-0F0E141199A2")]
   public interface IValueParameter : IParameter {
     IItem Value { get; set; }
@@ -30,4 +31,5 @@
   }
 
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("09CB4A88-9515-41C8-A7D8-4F03406157A6")]
   public interface IValueParameter<T> : IValueParameter where T : class, IItem {
     new T Value { get; set; }
Index: branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IVariable.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IVariable.cs	(revision 13401)
+++ branches/PersistenceOverhaul/HeuristicLab.Core/3.3/Interfaces/IVariable.cs	(revision 14712)
@@ -26,4 +26,5 @@
   /// Represents a variable which has a name and holds an IItem.
   /// </summary>
+  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("337D6940-0961-4B68-8EB4-A8A51387FD01")]
   public interface IVariable : INamedItem {
     IItem Value { get; set; }